<?php

include "CustomErrorHandler.php";
include "SonosIni.php";

set_time_limit(120);

$wochentag = $wochentage_arr[date("w")];
$uhrzeit = date(" H:i ");

// Parameter in der URL verarbeiten
if (!isset($_REQUEST['room']) || $_REQUEST['room'] == '') {
    $room = "FL";
} else {
    $room = $_REQUEST['room'];
}

if ($room !== '$all') {
    $room = $room_arr[$room];
}

if (!isset($_REQUEST['volume']) || $_REQUEST['volume'] == '') {
    $volume = 40;
} else {
    $volume = $_REQUEST['volume'];
}
$volumeg = $volume - 7;
if ($volumeg < 1) {
    $volumeg = 1;
}

if (!isset($_REQUEST['text']) || $_REQUEST['text'] == '') {
    $text = "Test";
} else {
    $text = $_REQUEST['text'];
}

if (isset($_REQUEST['sound'])) {
    $sound = $_REQUEST['sound'];
    
// der else Zweig wird bentigt, um kompatibel zur alten Schreibweise zu bleiben
} else {
    $sound = "";

    if (!isset($_REQUEST['gong']) || $_REQUEST['gong'] == '') {
        $gong = "off";
    } else {
        $gong = $_REQUEST['gong'];
    }

    if (!isset($_REQUEST['horn']) || $_REQUEST['horn'] == '') {
        $horn = "off";
    } else {
        $horn = $_REQUEST['horn'];
    }

    if (!isset($_REQUEST['ship']) || $_REQUEST['ship'] == '') {
        $ship = "off";
    } else {
        $ship = $_REQUEST['ship'];
    }

    if (!isset($_REQUEST['synth1']) || $_REQUEST['synth1'] == '') {
        $synth = "off";
    } else {
        $synth = $_REQUEST['synth1'];
    }

    if (!isset($_REQUEST['alarm1']) || $_REQUEST['alarm1'] == '') {
        $alarm = "off";
    } else {
        $alarm = $_REQUEST['alarm1'];
    }
}
// $time schortcut verarbeiten
if ($text == '$time') {
    $text = "Es ist jetzt " . $uhrzeit;
}
// $goodmorning shortcut verarbeiten
if ($text == '$goodmorning') {
    $text = "Guten Morgen! Alle aufstehen! Heute ist " . $wochentag .
        "! Es ist jetzt " . $uhrzeit;
}

// Text encoden
$text = trim(rawurlencode($text));

// aktueller Status des Players im Raum
$curl = curl_init();
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($curl, CURLOPT_TIMEOUT, 40);
$url = $sonos_url . "/" . $room . "/state/";
curl_setopt($curl, CURLOPT_URL, $url);
$sonos_state = curl_exec($curl);
curl_close($curl);
$jsonarr = json_decode($sonos_state);
$state = $jsonarr->{'playbackState'};

// wenn irgendwas luft, anhalten
if ($state != 'STOPPED') {
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curl, CURLOPT_TIMEOUT, 40);
    $url = $sonos_url . "/playpause/";
    curl_setopt($curl, CURLOPT_URL, $url);
    $sonos_state = curl_exec($curl);
    curl_close($curl);
}
// Ausgabe der aktuellen Nachricht
$curl = curl_init();
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($curl, CURLOPT_TIMEOUT, 40);

// wird bentigt um kompatibel zur alten Schreibweise zu sein
if ($sound == '') {
    if ($gong == 'on') {
        $sound = 'gong';
    } elseif ($horn == 'on') {
        $sound = 'horn';
    } elseif ($ship == 'on') {
        $sound = 'ship';
    } elseif ($synth == 'on') {
        $sound = 'synth';
    } elseif ($alarm == 'on') {
        $sound = 'alarm';
    }
}

// Sound vor der Ansage ausgeben
if ($sound != '') {
    switch ($room) {
        case "*all":
            $url = $sonos_url . "/clipall/";
        default:
            $url = $sonos_url . "/" .$room . "/clip/";
    }
    $url = $url . $sound_arr[$sound] . "/" . $volumeg;
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_exec($curl);
}

// Ansage ausgeben
if ($room == '$all') {
    $url = $sonos_url . "/sayall/" . $text . "/de/" . $volume;
} else {
    $url = $sonos_url . "/" . $room . "/say/" . $text . "/de/" . $volume;
}
curl_setopt($curl, CURLOPT_URL, $url);
curl_exec($curl);
curl_close($curl);

// ggfs. weiter machen, wo wir unterbrochen hatten
if ($state == 'STOPPED') {
    die();
}
$curl = curl_init();
curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($curl, CURLOPT_TIMEOUT, 40);
$url = $sonos_url . "/" . $room . "/playpause/";
curl_setopt($curl, CURLOPT_URL, $url);
$sonos_state = curl_exec($curl);
curl_close($curl);

?>
